-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt
local M = {}

local watertime
local watercooldown
local spraytime

local function onInit()
	electrics.values['water_1a'] = 0
	electrics.values['water_1b'] = 0
	electrics.values['water_2a'] = 0
	electrics.values['water_2b'] = 0
	--these control the thrusters
	electrics.values['extinguisherDetached'] = 0
	electrics.values['extinguisherBroken'] = 0
	watertime = 0
	watercooldown = 0
	spraytime = 0
end


local function enableWater(dt, waterA, waterB, type_a, type_b)

  --will stop spraying after 20 seconds
  if spraytime > 20 then
    electrics.values['water_1a'] = 0
	electrics.values['water_1b'] = 0
	electrics.values['water_2a'] = 0
	electrics.values['water_2b'] = 0
	electrics.values['extinguisherDetached'] = 0
	electrics.values['extinguisherBroken'] = 0
	return
  end

  watertime = watertime + dt
  spraytime = spraytime + dt
  if watertime > 0.05 then
	watertime = 0
	watercooldown = 0.05
  end
  if watercooldown > 0 then
	watertime = 0
	watercooldown = watercooldown - dt
	waterA = 0
	waterB = 1
  else
	watercooldown = 0
	waterA = 1
	waterB = 0
  end

  electrics.values[type_a] = waterA
  electrics.values[type_b] = waterB

end


local function updateGFX(dt)

	--HANDLE WATER EFFECT--
	
	local waterA = 0
	local waterB = 0
	
	electrics.values['extinguisherDetached'] = 0
	electrics.values['extinguisherBroken'] = 0
	
	for k, b in pairs(v.data.beams) do
	  if b.breakGroup == 'extinguisher_break' and obj:beamIsBroken(k) then electrics.values['extinguisherBroken'] = 1
	  elseif b.breakGroup == 'extinguisher_hinge_break' and obj:beamIsBroken(k) then electrics.values['extinguisherDetached'] = 1 end
	end
	
	if electrics.values['extinguisherDetached'] == 1 and electrics.values['extinguisherBroken'] == 0 then 
	  enableWater(dt, waterA, waterB, 'water_1a', 'water_1b') 
	end
	if electrics.values['extinguisherBroken'] == 1 then 
	  enableWater(dt, waterA, waterB, 'water_2a', 'water_2b') 
	end
	
end


-- public interface
M.enableWater = enableWater
M.onInit      = onInit
M.onReset     = onInit
M.updateGFX   = updateGFX

return M