-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt
local M = {}

local cylinderToFire

local function onInit()
    
	cylinderToFire = 1
	
end

local function updateGFX(dt)
   
   for i = 1, 8 do
     electrics.values['firingorder' .. i] = 0
   end
   
   if not electrics.values.rpm or electrics.values.rpm == 0 then return end
   if engineRunning == 0 then return end
   
   local rps = electrics.values.rpm/60
   local cylindersFired = round(rps * dt * 1000)
   cylinderToFire = (cylinderToFire + cylindersFired) % 8 + 1
   
   electrics.values['firingorder' .. cylinderToFire] = 1
   
end


-- public interface
M.onInit      = onInit
M.onReset     = onInit
M.updateGFX = updateGFX

return M