-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt
local M = {}

local handbrakeDelay = 0
local previousInput = 0
local handbrakeDelayTime = 0

local function onInit()
    electrics.values['handbrakeStick'] = 0
	handbrakeDelay = 0
	previousInput = 0
	--handbrake animation delay depends if there is a dummy driver in the car or not
	handbrakeDelayTime = electrics.values['handbrake_delay_time'] or 0.1
end

local function updateGFX(dt)
    if not electrics.values['parkingbrake_input'] then return end

    local handbrakeStick = 1.0
	
	if electrics.values['parkingbrake_input'] == 0 then 
	  handbrakeStick = 1.0 
	  previousInput = 0
	end
	
	--delayed animation to match with the driver arm movement
	if electrics.values['parkingbrake_input'] == 1 then
	
	  if previousInput == 0 then
	    handbrakeDelay = handbrakeDelayTime
	    previousInput = 1		
	  else	  
	  
	    if handbrakeDelay > 0 then
	      handbrakeDelay = handbrakeDelay - dt
		  if handbrakeDelay < 0.1 then 
		    handbrakeDelay = 0.1
		    handbrakeStick = 0.5 
		  end
	    end
		
	  end
	  
	end	

    electrics.values['handbrakeStick'] = handbrakeStick
end

-- public interface
M.onInit      = onInit
M.onReset     = onInit
M.updateGFX = updateGFX

return M