-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt
local M = {}

local gearbox
local previousGear
local seqTimerUp
local seqTimerDn

local function onInit()
    electrics.values['shifterX'] = 0
	electrics.values['shifterZ'] = 0
	gearbox = powertrain.getDevice('gearbox')
	previousGear = electrics.values['gear_M'] or 0
	seqTimerUp = 0
	seqTimerDn = 0
end

local function updateGFX(dt)
    if not electrics.values['gear_M'] or electrics.values['gear_A'] ~= 0 then --uses automatic gearbox or none
	  
	  electrics.values['shifterX'] = electrics.values['gear_A'] or 0
	  electrics.values['shifterZ'] = -0.1745329252 --10 degrees
		
	else --uses manual or sequential gearbox
	
	  if gearbox and gearbox.type == 'sequentialGearbox' then --uses sequential gearbox
	    electrics.values['shifterX'] = 0.6
	    if electrics.values['gear_M'] > previousGear then
		  seqTimerUp = 0.25
		  previousGear = electrics.values['gear_M']
		elseif electrics.values['gear_M'] < previousGear then
		  seqTimerDn = 0.25
		  previousGear = electrics.values['gear_M']	
		end
		
		if seqTimerUp > 0 then
		  electrics.values['shifterX'] = 0.2
		  seqTimerUp = seqTimerUp - dt
		else
		  seqTimerUp = 0
		end
		
		if seqTimerDn > 0 then
		  electrics.values['shifterX'] = 1
		  seqTimerDn = seqTimerDn - dt
		else
		  seqTimerDn = 0
		end
	
	  else --uses manual gearbox
	  
	    electrics.values['shifterZ'] = electrics.values['gear_M'] / 25 - 0.1
	
	    if electrics.values['gear_M'] % 2 == 0 then 
	      electrics.values['shifterX'] = 0.2
	    else
	      electrics.values['shifterX'] = 1
	    end
	  
	    if electrics.values['gear_M'] == 0 then   
	      electrics.values['shifterX'] = 0.6
		  electrics.values['shifterZ'] = 0
	    end
		
	  end
	  
	end
	
end

-- public interface
M.onInit      = onInit
M.onReset     = onInit
M.updateGFX = updateGFX

return M