-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt
local M = {}

local function onInit()
    electrics.values['spotlight_L'] = 0
	electrics.values['spotlight_R'] = 0
	electrics.values['spotlight_L_light'] = 0
	electrics.values['spotlight_R_light'] = 0
end

local function updateGFX(dt)

	--open position - default if error
	electrics.values['spotlight_L'] = 0
	electrics.values['spotlight_R'] = 0
	electrics.values['spotlight_L_light'] = 0
	electrics.values['spotlight_R_light'] = 0
	
	--check for errors
    if not electrics.values['signal_left_input']  then return end
	if not electrics.values['signal_right_input'] then return end
	if not electrics.values['highbeam'] then return end

	--closed position - default if no error
    electrics.values['spotlight_L'] = 1
	electrics.values['spotlight_R'] = 1
	
	--outwards position for turn signals
	if electrics.values['signal_left_input']  == 1 then electrics.values['spotlight_L'] = -2 end
	if electrics.values['signal_right_input'] == 1 then electrics.values['spotlight_R'] = -2 end
	
	--straighten out if active
	if electrics.values['highbeam'] == 1 then 
		electrics.values['spotlight_L'] = 0
		electrics.values['spotlight_R'] = 0
	end
	
	--lights
	if electrics.values['highbeam'] == 1 and electrics.values['signal_left_input']  == 0 then electrics.values['spotlight_L_light'] = 1 end
	if electrics.values['highbeam'] == 1 and electrics.values['signal_right_input'] == 0 then electrics.values['spotlight_R_light'] = 1 end
	
end

-- public interface
M.onInit      = onInit
M.onReset     = onInit
M.updateGFX = updateGFX

return M